/***************************************************************************
                          gamedimsdlg.cpp  -  description
                             -------------------
    begin                : Wed Jul 12 2000
    copyright            : (C) 2000 by Hans Kopp
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "gamedimsdlg.h"

#include <kapp.h>

#include <qlabel.h>
#include <qlineedit.h>
#include <qvalidator.h>
#include <qstring.h>
#include <qlayout.h>
#include <qpushbutton.h>

GameDimsDlg::GameDimsDlg(const CGameDim &gameDim)
{
#define PREPW(x) (x)->setMinimumSize((x)->sizeHint())
	QLabel *pWidthLabel = new QLabel(i18n("Width"), this); 	PREPW(pWidthLabel);
	QLabel *pHeightLabel = new QLabel(i18n("Height"), this); PREPW(pHeightLabel);	
	QLabel *pMinesLabel = new QLabel(i18n("Mines"), this); PREPW(pMinesLabel);	

	QLineEdit *pWidthEdit = new QLineEdit(this);
	pWidthEdit->setValidator(new QIntValidator(this));
	pWidthEdit->setText(QString().setNum(m_gameDim.m_nSizeX));
	PREPW(pWidthEdit);
	
	QLineEdit *pHeightEdit = new QLineEdit(this);
	pHeightEdit->setValidator(new QIntValidator(this));
	pHeightEdit->setText(QString().setNum(m_gameDim.m_nSizeY));
	PREPW(pHeightEdit);
	
	QLineEdit *pMinesEdit = new QLineEdit(this);
	pMinesEdit->setValidator(new QIntValidator(this));
	pMinesEdit->setText(QString().setNum(m_gameDim.m_nMines));
	PREPW(pMinesEdit);

	
	QGridLayout *pLayoutAll = new QGridLayout(this, 5,3);
	QGridLayout *pLayout = new QGridLayout(5,3);
	QGridLayout *pOkCancelLayout = new QGridLayout(1, 3);
	pLayoutAll->addLayout(pLayout, 1,1); 	
	pLayoutAll->addLayout(pOkCancelLayout, 3,1); 	
	
	pLayout->addWidget(pWidthLabel, 0,0); 	
	pLayout->addWidget(pWidthEdit, 0,2); 	
  pLayout->addWidget(pHeightLabel, 2,0);
  pLayout->addWidget(pHeightEdit, 2,2); 	
  pLayout->addWidget(pMinesLabel, 4,0); 	
  pLayout->addWidget(pMinesEdit, 4,2); 	
	pLayout->setColStretch(1, 3);
	pLayout->setRowStretch(1, 3);
	pLayout->setRowStretch(3, 3);
	//pLayout->activate();
	
	QPushButton *pOK = new QPushButton(i18n("OK"), this); PREPW(pOK);	
	QPushButton *pCancel = new QPushButton(i18n("Cancel"), this); PREPW(pCancel);	
	
	pOkCancelLayout->addWidget(pOK,0,0);
	pOkCancelLayout->addWidget(pCancel,0,2);
	pOkCancelLayout->setColStretch(1, 3);
	//pOkCancelLayout->activate();
	
	pLayoutAll->setColStretch(0, 3);
	pLayoutAll->setColStretch(2, 3);
	pLayoutAll->setRowStretch(0, 3);
	pLayoutAll->setRowStretch(2, 3);
	pLayoutAll->setRowStretch(4, 3);
	pLayoutAll->activate();
	
#undef PREPW		
	

	resize(0,0);
}

bool GameDimsDlg::getGameDims(CGameDim &gameDim)
{
	gameDim = m_gameDim;
	return true;
}
