/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sam Jul  8 17:02:46 CEST 2000
    copyright            : (C) 2000 by Hans Kopp
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mineui_kde.h"

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#include "uidrawcontextkde.h"
#include <gamecontrol/CGameManager.h>
#include <gamecontrol/CGlobalResourceSet.h>
#include <qmessagebox.h>

static QString getMineIconPath(const char *pszIconFilename) {
  return kapp->kde_datadir() + QString("/mineui_kde/") + QString(pszIconFilename);

  // the path below points to the location of the bitmaps in the dev environment
	// return QString("../../resources/") + QString(pszIconFilename);
}

int main(int argc, char *argv[])
{
   KApplication a(argc, argv, "mineui_kde");

   // initialize minesweeper
   if (CUISystemKDE::instance() == NULL)
   {      CUISystemKDE::setInstance(new CUISystemKDE);
   }

   if (CGlobalResourceSet::instance() == NULL)
   {
      CGlobalResourceSet *pRes = new CGlobalResourceSet;
      CUISystemKDE *pKDESys = CUISystemKDE::instanceKDE();
		
      std::auto_ptr<CIconSetBase> pSmilies(pKDESys->loadIconSet(getMineIconPath("Smilies.bmp"), IconType::SMILIE_COUNT, 1));
      pRes->m_pSmilies = pSmilies;
      std::auto_ptr<CIconSetBase> pDigits(pKDESys->loadIconSet(getMineIconPath("Digits.bmp"), IconType::DIGIT_COUNT, 1));
      pRes->m_pDigits = pDigits;
      std::auto_ptr<CIconSetBase> pFieldIcons(pKDESys->loadIconSet(getMineIconPath("FieldIcons.bmp"), IconType::FIELD_COUNT, 1));
      pRes->m_pFieldIcons = pFieldIcons;
      std::auto_ptr<CIconSetBase> pFieldInfos(pKDESys->loadIconSet(getMineIconPath("FieldInfos.bmp"), IconType::FIELDINFO_COUNT, 1));
      pRes->m_pFieldInfoIcons = pFieldInfos;

      if (!pRes->isValid())
      {
      	QMessageBox::critical(NULL, "Fatal error", QString("Unable to load bitmaps\nExpected location: ") + getMineIconPath("")
      	    + "\nYou have to call 'make install' with root permissions to copy the bitmaps to this location\n"
      	    + "Optionally you can simply modify the path in mineui_kde/mineui_kde/main.cpp:getMineIconPath()");
        fprintf(stderr, "Unable to load bitmaps\n");
        exit(1);
      }

      CGlobalResourceSet::setInstance(pRes);
  }                                                                                                                 	

  // start kde
  MineUI_KDE *mineui_kde = new MineUI_KDE();
  a.setMainWidget(mineui_kde);
  mineui_kde->show();  

  return a.exec();
}
