/***************************************************************************
                          mineui_kde.h  -  description
                             -------------------
    begin                : Sam Jul  8 17:02:46 CEST 2000
    copyright            : (C) 2000 by Hans Kopp
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MINEUI_KDE_H
#define MINEUI_KDE_H

#include <kapp.h>
#include <qwidget.h>
#include <ktopwidget.h>
#include <mineui_common/CLevelMgr.h>

class KMenuBar;
class QPopupMenu;
class MineUIView;


class MineUI_KDE : public KTopLevelWidget
{
  Q_OBJECT 
  public:
    /** construtor */
    MineUI_KDE(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~MineUI_KDE();

	private:
		KMenuBar *m_pMenu;
	  QPopupMenu *m_pFilePopup, *m_pHelpPopup;
	  MineUIView *m_pView; 		
		CLevelMgr m_levelMgr;
	
		enum GameLevelIDs {
			FILE_MENU_BEGINNER=20,
			FILE_MENU_ADVANCED,
			FILE_MENU_EXPERT,
			FILE_MENU_USERDEFINED
		};
	
  private: 	
	  void adjustToClientSize();
		void updateMenuState();
	
	private slots:
		void newGameSlot();	
		void aboutSlot();
		void setGameLevelSlot(int nGameLevelID);
		void toggleMarkerSlot();
		void showHallOfFameSlot();
		void exitSlot();
};

#endif
