/***************************************************************************
                          persistentdictkde.cpp  -  description
                             -------------------
    begin                : Sat Sep 2 2000
    copyright            : (C) 2000 by Hans Kopp
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          PersistentDictKDE.cpp  -  description
                             -------------------
    begin                : Sat Sep 2 2000
    copyright            : (C) 2000 by Hans Kopp
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "persistentdictkde.h"
#include <kapp.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPersistentDictKDE::CPersistentDictKDE()
{

}

CPersistentDictKDE::~CPersistentDictKDE()
{

}

bool CPersistentDictKDE::getString(const char *szKey, std::string &val) const
{
	KConfig *kconf = kapp->getConfig();
	if (!kconf->hasKey(szKey))
		return false;
		
	QString qstrLevel = kconf->readEntry(szKey, val.c_str());
	val = std::string(qstrLevel);
	return true;
}
bool CPersistentDictKDE::setString(const char *szKey, const std::string &val)
{
	KConfig *kconf = kapp->getConfig();
	kconf->writeEntry(szKey, val.c_str());
	kconf->sync();
	return true;
}

bool CPersistentDictKDE::getInt(const char *szKey, int &nVal) const
{
	KConfig *kconf = kapp->getConfig();
	if (!kconf->hasKey(szKey))
		return false;
		
	nVal = kconf->readNumEntry(szKey, nVal);
	return true;
}
bool CPersistentDictKDE::setInt(const char *szKey, int nVal)
{
	KConfig *kconf = kapp->getConfig();
	kconf->writeEntry(szKey, nVal);
	kconf->sync();
	return true;
}

bool CPersistentDictKDE::getBool(const char *szKey, bool &bVal) const
{
	KConfig *kconf = kapp->getConfig();
	if (!kconf->hasKey(szKey))
		return false;

	bVal = kconf->readBoolEntry(szKey, bVal);			
	return true; 	
}
bool CPersistentDictKDE::setBool(const char *szKey, bool bVal)
{
	KConfig *kconf = kapp->getConfig();
	kconf->writeEntry(szKey, bVal);
	kconf->sync();
	return true;
}
